// NoPro - webwork 2013

/*
 * hide nopro-lib (js)-scripts
 */

// some globals
var CID0
, CID1
, CID2

// diffie-hellman key-exchange
, d0	// dh common generator
, e0	// dh common prime
, a0	// Alice's secret
, a1	// Alice's public
, b0	// Bob's secret
, b1	// Bob's public
, c0	// common session-key
;

try {
    if(document.cookie) {
	$.each(document.cookie.split(';'), function(k,v) {
	    var c = v.split('=');
	    if(c[0].trim() == 'dhpub') {
		var dhp = c[1].split('.');
		d0 = str2bigInt(dhp[0], 10, 80);	// generator
		e0 = str2bigInt(dhp[1], 10, 80);	// prime
		return;
	    }
	});
    } else
	throw('no cookie set');
    
    CID0 = new Date().getTime();	// now
    CID2 = parseInt(CID0 * (1+Math.random())); // secret
    a0 = int2bigInt(CID2, 1024);	// secret
    a1 = powMod(d0, a0, e0);		// public
    CID2 = bigInt2str(a1, 62); 		// public
    
} catch(m) { alert("liblock "+ m); }

function nplreq(url) {

    var xreq = '';
    if(!document.cookie)
	xreq = '&cid0='+ CID0 +'&cid2='+ CID2;
    else {
	document.cookie = 'cid0='+ CID0;
	document.cookie = 'cid2='+ CID2;
    }
    
    $.ajax({
	'async': false,
	'url': url + xreq,
	/**/
	'error': function(ax, status, ae) {
	    alert("err: "+ae);
	    dbg('err: '+status+', '+ae, true);
	    dump_obj(ax, true);
	},
	/**/
	'success': function(ad, status, ax) {
	    if(typeof(ad) != 'object') {
		return;
	    }
	    b1 = str2bigInt(ad['cid2'], 62);
	    c0 = powMod(b1, a0, e0);

	    var z0 = bigInt2str(c0, 62).substr(0,32)
	    //z0 = bigInt2str(c0, 62).toLowerCase().substr(0,32)		// only necessary for hex
	    , z1 = base64_decode(ad['init'])
	    , z2 = base64_decode(ad['text'])	// ciph

	    // decode
	    , text = mcrypt.Decrypt(z2, z1, z0, 'rijndael-256', 'cbc')
	    , i, txt, JS='';
	    // remove trailing 0-chars
	    for(i=text.length-64; i<text.length; i++) {
		if(text.charCodeAt(i) == 0)
		    text = text.substr(0,i);
	    }

	    // build JS
	    eval('txt = '+ text +';');
	    for(i=0; i<txt['s'].length; i++) {
		JS += txt.c[i];
		JS += txt.s[i];
	    }
	    JS += txt.c[i];
	    //$('body').append('<script>try{'+ JS +xx+'}catch(e){alert("err "+e+": "+url)}</script>');
	    $('body').append('<script>'+ JS +'</script>');
	}
    });
}
