// NoPro - webwork 2007-2013

/*
 * some handy js-functions
 * compatilble with firefox, chrome, konqueror (safari), ms-ie
 */

function nopro_min(a, b) { return (a < b) ? a : b; }
function nopro_max(a, b) { return (a > b) ? a : b; }
function nopro_is_array(v) { return typeof(v)=='object'&&(v instanceof Array); }

function _winwidth() { return window.innerWidth; }
function _winheight() { return window.innerHeight; }

function winwidth() {
    var sec = document.getElementById("SE_dot");
    if(!sec) { return _winwidth(); }
    return sec.offsetLeft;
}

function winheight() {
    var sec = document.getElementById("SE_dot");
    if(!sec) { return _winheight(); }
    return sec.offsetTop;
}

function hidebox(id) {
    if(!id) {return null;}
    var box = document.getElementById(id);
    if(box) {
	box.style.zIndex = -1;
	box.style.display = 'none';
    }
    return box;
}

function showbox(id) {
    if(!id) {return null;}
    var box = document.getElementById(id);
    if(box) {
	box.style.zIndex = 2;
	box.style.display = 'block';
    }
    return box;
}

function absolve(id) {
    // make psoition absolute
    if(!id) {return null;}
    var box = document.getElementById(id);
    if(!box) {return;}
    var bs = box.style;
    if(!bs.left) { bs.left = box.offsetLeft +"px"; }
    if(!bs.top)  { bs.top  = box.offsetTop  +"px"; }
    bs.position = "absolute";
}

function get_msie() {
    // return version of M$ Internet Explorer
    var browser = navigator.appVersion;
    var ms = browser.indexOf('MSIE');
    if(ms > 0) {
	MSIE = browser.substr(ms + 5);
	return MSIE.substr(0, MSIE.indexOf(';'));
    }
    return null;
}

function is_mobile() {
    // return mobile
    return navigator.userAgent.match(/(iPad)|(iPhone)|(iPod)|(android)|(webOS)/i);
}

function scrolldown(jso) { jso.scrollTop = jso.scrollHeight; }
function img_width(o)  { return (o.width > 0)  ? o.width  : o.naturalWidth; }
function img_height(o) { return (o.height > 0) ? o.height : o.naturalHeight; }


var crlf = "\r\n";

/* -.-.- */

//////////////// resize objects (animated)
function resizeme(box, w, h, steps) {
    if(!box) { return; }

    var bs = box.style;
    var cw = parseInt(bs.width);
    var ch = parseInt(bs.height);
    var dx = w - cw;
    var dy = h - ch;
    
    if(!dx && !dy) { return; }
    if(!steps) { return final(); }

    function animate() {
        var sx = Math.round(dx / steps);
        var sy = Math.round(dy / steps);
	cw += sx; ch += sy;
	bs.width  = cw +"px";
	bs.height  = ch +"px";
    }
    
    var period = 200;
    var t1 = setInterval(animate, 5+Math.ceil(period / steps));
    var t2 = setTimeout(final, period);

    function final() {
	clearTimeout(t1);
	bs.width  = w +"px";
	bs.height = h +"px";
    }

}

//////////////// enable dragging around of objects
////////////////
/*some global vars for dragging */
var follow = null;	// current obj to drag around
var lastzi = 1;		// highest z-index for drag-objs
var limits = null;	// region to stay inside
var x0, y0, fx1, fy1;
function drag(obj, eve, sib, area) {
    // make obj that was clicked on, to be dragged around 
    if(eve == null) { eve = window.event; }
    var sender = (typeof(window.event) != "undefined") ? eve.srcElement : eve.target;
    if(sender != obj && !sib) { return false; }
    obj.style.zIndex = ++lastzi;
    follow = obj;
    // ensure that positioning css-vals are set
    if(!follow.style.left) { follow.style.left = follow.offsetLeft +"px"; }
    if(!follow.style.top)  { follow.style.top  = follow.offsetTop  +"px"; }
    //mousemove = true;
    x0 = eve.clientX;
    y0 = eve.clientY;
    fx1 = parseInt(follow.style.left);
    fy1 = parseInt(follow.style.top);
    if(area != undefined) {
	limits = area;
    }
    if(!is_mobile()) {
	document.onmouseup = drop;
	document.onmousemove = dragit;
    }
    return false;
}

function dragit(eve) {
    // drag that thing along with mousemoves
    if(!follow) { return true; }
    if(follow) {
	if (eve == null) { eve = window.event;}
	var x1, y1;
	if(eve.type == 'touchmove') {
	    eve.preventDefault();
	    var touch = eve.originalEvent.touches[0] || eve.originalEvent.changedTouches[0];
	    x1 = fx1 + touch.clientX - x0;
	    y1 = fy1  + touch.clientY - y0;
	} else {
	    x1 = fx1 + eve.clientX - x0;
	    y1 = fy1 + eve.clientY - y0;
	}
	if(limits != null) {
	    if(limits.l > x1) { x1 = limits.l; }
	    if(limits.r < x1) { x1 = limits.r; }
	    if(limits.t > y1) { y1 = limits.t; }
	    if(limits.b < y1) { y1 = limits.b; }
	}
	follow.style.left = x1 +"px";
	follow.style.top  = y1 +"px";
    }
    return false;    
}

function drop() {
    // simply stop dragging (reset)
    document.onmousemove = null;
    document.onmouseup = null;

    //limits = null;
    follow = null;
    return false;    
}
////////////////
//////////////// enable user-resize of objects
////////////////
/*some global vars for dragging */
var plane = null;	//  current obj to resize
var ox1, oy1, ow1, oh1;
var dx, dy;

function usr_resize(eve) {
    if(eve == null) { return false; }
    var dot = eve.target;	//  corner of obj to resize
    plane = dot.parentNode;
    // ensure that positioning css-vals are set
    if(!plane.style.height) { plane.style.height = plane.offsetHeight +"px"; }
    if(!plane.style.width)  { plane.style.width  = plane.offsetWidth +"px"; }
    if(!plane.style.left)   { plane.style.left   = plane.offsetLeft +"px"; }
    if(!plane.style.top)    { plane.style.top    = plane.offsetTop  +"px"; }

    x0 = eve.clientX;
    y0 = eve.clientY;
    ox1 = parseInt(plane.style.left);
    oy1 = parseInt(plane.style.top);
    ow1 = parseInt(plane.style.width);
    oh1 = parseInt(plane.style.height);
    
    if(dot.offsetLeft > 0) {dx = 1;} else {dx = -1;}
    if(dot.offsetTop  > 0) {dy = 1;} else {dy = -1;}
    
    document.onmouseup = usr_done;
    document.onmousemove = resizeit;

    return false;	// end event-handler-chain
}

function resizeit(eve) {
    if(plane) {
	var dw = eve.clientX - x0;
	var dh = eve.clientY - y0;
	
	plane.style.width = ow1 + dx * dw + "px"; 
	plane.style.height = oh1 + dy * dh + "px"; 
	if(dx < 0) { plane.style.left = ox1 + dw + "px"; }
	if(dy < 0) { plane.style.top =  oy1 + dh + "px"; }
    }
    return false;	// end event-handler-chain
}

function usr_done() {
    document.onmousemove = null;
    document.onmouseup = null;
    plane = null;
    
    return false;	// end event-handler-chain
}
////////////////
