<?php

/* NoPro handy-lib
 * parser for html-docs (DOM someday?)
 * inherited by jsparser
 */

require_once('nopro_handy.php');

if(!defined('CRLF')) define('CRLF', PHP_EOL);

function wrap_4dbg($txt) { return preg_replace("/([}{;])/", "$1".CRLF, $txt); }

class parser {
  private $txt = '', $uri = '';
  public function get_uri() { return $this->uri; }

  public $rems = array();		// array of remarks, bpa (positions $bp1 => $bp2), not nested
  public $tabs = array();		// array of tables, bpa, nested
  public $divs = array();		// array of divs, as bpa, nested

  public function parser($url, $pp=false) { $this->load($url); if($pp) $this->preparse(); }
  public function load($url) {
    $this->uri = $url;
    $this->txt = file_get_contents($url);
    if($this->txt === false) {
      $this->txt = '';
    }
    return strlen($this->txt);
  }

  private function tagpos(&$txt, $tag, $bp0, $bp1, &$skips) {
    $bp = $bp0-1;
    do {
      $bp = strpos($txt, $tag, $bp+1);
      if($bp > $bp1 || $bp === false) return false;
    } while($skips && bpa_contains($skips, $bp));
    return $bp;
  }
  
  public function blockscan($tag0, $tag1, $nest=true, $skips = true, $bp0 = 0, $bp1 = 0, $txt = NULL) {
    // return bp-array of all found blocks delimited by $tag0 and $tag1 inside [$bp0:$bp1]
    
    if($skips === true) $skips = &$this->rems;
    if($txt == NULL) $txt = &$this->txt;
    if($bp1 == 0) $bp1 = strlen($txt);

    $blocks = array();
    $tl0 = strlen($tag0);
    $tl1 = strlen($tag1);
    
    if($nest) {
      // no recursion here but build 2 arrays
      // and merge them from inner to outer blocks
      $arr0 = array();
      $arr1 = array();
      for($bp = $bp0; $bp < $bp1; $bp += $tl0) {
	$bp = $this->tagpos($txt, $tag0, $bp, $bp1, $skips);
	if($bp === false) break;
	array_push($arr0, $bp);
      }
      if(count($arr0) == 0)
	return array();
      for($bp = $arr0[0]; $bp < $bp1; $bp += $tl1) {
	$bp = $this->tagpos($txt, $tag1, $bp, $bp1, $skips);
	if($bp === false) break;
	array_push($arr1, $bp);
      }
      
      #print_r($arr0);
      #print_r($arr1);
      
      for($i=0; $i < count($arr1); $i++) {
	$p1 = $arr1[$i];
	for($j=1, $j0=0; $j < count($arr0); $j++) {
	  if($p1 < $arr0[$j])
	    break;
	  $j0 = $arr0[$j] ? $j : $j0;
	}
	$p0 = $arr0[$j0];
	$arr0[$j0] = 0;
	$blocks[$p0] = $p1;
      }
      ksort($blocks);
    } else {
      // not nested straight-forward 
      for($bp = $bp0; $bp < $bp1; ) {
	$bp = $this->tagpos($txt, $tag0, $bp, $bp1, $skips);
	if($bp === false) break;
	$b1 = $this->tagpos($txt, $tag1, $bp+$tl0, $bp1, $skips);
	if($b1 === false) break;
	$blocks[$bp] = $b1;
	$bp = $b1 + $tl1;
      }
    }
    return $blocks;
  }
    
  public function preparse($type = "HTML") {
    // build remarks array and scan for tables
    $this->rems = $this->blockscan('<!--', '-->', false, null);
    $this->tabs = $this->blockscan('<table', '</table');
    $this->divs = $this->blockscan('<div', '</div');
  }

}

function bpa_contains(&$bpa, $p) {
  // check if $p is covered with $bpa
  $keys = array_keys($bpa);
  $i = bsearch($keys, $p);
  return ($p < $bpa[$keys[$i]]);
}

?>
